/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	MgrGrpData.cpp												 */
/* eF		OtBbNf[^ǗNX t@C					 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/03/29													 */
/* ========================================================================= */

#include "../stdafx.h"
#include "Lib/Img32.h"
#include "Lib/Png/png.h"
#include "MgrGrpData.h"


/* ========================================================================= */
/* \̒`																 */
/* ========================================================================= */

typedef struct{
	PBYTE	Buffer;
	int		Pos;
} TPngFileBuffer;


/* ========================================================================= */
/* ֐F	CMgrGrpData::CMgrGrpData										 */
/* eF	RXgN^													 */
/* tF	2006/03/29														 */
/* ========================================================================= */

CMgrGrpData::CMgrGrpData()
{
	m_hDll			= NULL;
	m_pImgFont		= new CImg32;
	m_pImgFood		= new CImg32;
	m_pImgBack		= new CImg32;
	m_pImgPlayer	= new CImg32;
	m_pImgTitle		= new CImg32;
	m_pImgZako		= new CImg32;
}


/* ========================================================================= */
/* ֐F	CMgrGrpData::~CMgrGrpData										 */
/* eF	fXgN^													 */
/* tF	2006/03/29														 */
/* ========================================================================= */

CMgrGrpData::~CMgrGrpData()
{
	SAFE_FREELIBRARY (m_hDll);
	SAFE_DELETE (m_pImgFont);
	SAFE_DELETE (m_pImgFood);
	SAFE_DELETE (m_pImgBack);
	SAFE_DELETE (m_pImgPlayer);
	SAFE_DELETE (m_pImgTitle);
	SAFE_DELETE (m_pImgZako);
}


/* ========================================================================= */
/* ֐F	CMgrGrpData::Load												 */
/* eF	ǂݍ														 */
/* tF	2006/03/29														 */
/* ========================================================================= */

BOOL CMgrGrpData::Load(void)
{
	BOOL bRet;

	bRet = FALSE;

	/* tHg */
//	Read ("IDP_FONT", &m_pImgFont, 1);
	m_pImgFont->SetColorKey (RGB (255, 0, 255));
	/* Hו */
//	Read ("IDP_FOOD", &m_pImgFood, 1);
	m_pImgFood->SetColorKey (RGB (255, 0, 255));
	/* wi */
//	Read ("IDP_BACK", &m_pImgBack, 1);
	m_pImgBack->SetColorKey (RGB (255, 0, 255));
	/* vC[ */
	Read ("IDP_PLAYER", &m_pImgPlayer, 2);
	m_pImgPlayer->SetColorKey (RGB (255, 0, 255));
	/* ^Cg */
//	Read ("IDP_TITLE", &m_pImgTitle, 1);
	m_pImgTitle->SetColorKey (RGB (255, 0, 255));
	/* UR */
//	Read ("IDP_ZAKO", &m_pImgZako, 1);
	m_pImgZako->SetColorKey (RGB (255, 0, 255));

	bRet = TRUE;
	return bRet;
}


/* ========================================================================= */
/* ֐F	CMgrGrpData::GetDibFont											 */
/* eF	tHg摜C[W擾										 */
/* tF	2006/03/29														 */
/* ========================================================================= */

PCImg32 CMgrGrpData::GetDibFont(void)
{
	return m_pImgFont;
}


/* ========================================================================= */
/* ֐F	CMgrGrpData::GetDibFood											 */
/* eF	Hו摜C[W擾										 */
/* tF	2006/03/29														 */
/* ========================================================================= */

PCImg32 CMgrGrpData::GetDibFood(void)
{
	return m_pImgFood;
}


/* ========================================================================= */
/* ֐F	CMgrGrpData::GetDibBack											 */
/* eF	wi摜C[W擾											 */
/* tF	2006/03/29														 */
/* ========================================================================= */

PCImg32 CMgrGrpData::GetDibBack(void)
{
	return m_pImgBack;
}


/* ========================================================================= */
/* ֐F	CMgrGrpData::GetDibPlayer										 */
/* eF	vC[摜C[W擾									 */
/* tF	2006/03/29														 */
/* ========================================================================= */

PCImg32 CMgrGrpData::GetDibPlayer(void)
{
	return m_pImgPlayer;
}


/* ========================================================================= */
/* ֐F	CMgrGrpData::GetDibTitle										 */
/* eF	^Cg摜C[W擾										 */
/* tF	2006/03/29														 */
/* ========================================================================= */

PCImg32 CMgrGrpData::GetDibTitle(void)
{
	return m_pImgTitle;
}


/* ========================================================================= */
/* ֐F	CMgrGrpData::GetDibZako											 */
/* eF	UR摜C[W擾											 */
/* tF	2006/03/29														 */
/* ========================================================================= */

PCImg32 CMgrGrpData::GetDibZako(void)
{
	return m_pImgZako;
}


/* ========================================================================= */
/* ֐F	PngReadFunc														 */
/* eF	PNGǂݍݗpR[obN֐									 */
/* tF	2005/05/06														 */
/* ========================================================================= */

static void PngReadFunc(png_struct *Png,png_bytep buf,png_size_t size)
{
    TPngFileBuffer *PngFileBuffer = (TPngFileBuffer*)png_get_io_ptr (Png);
    memcpy (buf, PngFileBuffer->Buffer+PngFileBuffer->Pos, size);
    PngFileBuffer->Pos += size;
}


/* ========================================================================= */
/* ֐F	Read															 */
/* eF	PNGf[^̓ǂݍ												 */
/* tF	2005/05/06														 */
/* ========================================================================= */

BOOL CMgrGrpData::Read(LPSTR pszName, PCImg32 *pDib, int nSize)
{
	BOOL bRet;
	int x, y, BitDepth, ColorType, InterlaceType, CompressionType,
		FilterType, PaletteCount;
	PBYTE pTmp, pData;
	HDC hDCBmp, hDCBmp2;
	png_uint_32 Width, Height;
	png_struct *pPng;
	png_info *pInfo;
	png_byte *pLineBuf;
	TPngFileBuffer PngFileBuffer = {NULL, 0};
	CImg32 *pDibNew;
	CImg32 *pDibTmp, *pDibTmp2;

	bRet			= FALSE;
	PaletteCount	= 0;
	pPng			= NULL;
	pInfo			= NULL;
	pLineBuf		= NULL;
	pDibTmp			= NULL;
	pDibTmp2		= NULL;

	/* w肳ꂽ\[Xǂݍ */
	HGLOBAL hRes = LoadResource (m_hDll, FindResource (m_hDll, pszName, "PNG"));
	if (hRes == NULL) {
		goto Exit;
	}

	*pDib	= new CImg32;
	pDibTmp	= new CImg32;
	pDibNew	= *pDib;
	pPng	= NULL;
	pInfo	= NULL;

	pPng	= png_create_read_struct (PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	pInfo	= png_create_info_struct (pPng);

	PngFileBuffer.Buffer	= (BYTE *)LockResource (hRes);
	PngFileBuffer.Pos		= 0;

	png_set_read_fn (pPng, (png_voidp)&PngFileBuffer, (png_rw_ptr)PngReadFunc);

	png_read_info (pPng, pInfo);
	png_get_IHDR (pPng, pInfo, &Width, &Height, &BitDepth, &ColorType, &InterlaceType, &CompressionType, &FilterType);
	BitDepth = 8;

	png_set_bgr (pPng);

	png_colorp Palette;
	if (BitDepth == 8) {
		png_get_PLTE (pPng, pInfo, &Palette, &PaletteCount);
	}

	pLineBuf = new png_byte[Width * BitDepth / 8];

	pDibTmp->Create (Width, Height);
	pDibNew->CreateWithoutGdi (Width * nSize, Height * nSize);
	pData	= pDibTmp->GetBits ();
	pTmp	= pData;

	/* PCPNGf[^ǂݍ */
	for (y = 0; y < (int)Height; y ++) {
		png_read_row (pPng, pLineBuf, NULL);
		pTmp = pData + (Height - y - 1) * Width * 4;
		   for (x = 0; x < (int)Width; x ++) {
			BYTE *Src = pLineBuf + x * BitDepth / 8;
			if (BitDepth == 8) {
				pTmp[0] = Palette[*Src].blue;
				pTmp[1] = Palette[*Src].green;
				pTmp[2] = Palette[*Src].red;
			} else {
				CopyMemory (pTmp, Src, 3);
			}
			pTmp += 4;
		}
	}
	png_destroy_read_struct (&pPng, &pInfo, NULL);

	pDibTmp2 = new CImg32;
	pDibTmp2->Create (Width * nSize, Height * nSize);
	hDCBmp	= pDibTmp->Lock ();
	hDCBmp2	= pDibTmp2->Lock ();

	/* wTCYɊg債DIBɃRs[ */
	StretchBlt (hDCBmp2, 0, 0, Width * nSize, Height * nSize,
			hDCBmp, 0, 0, Width, Height, SRCCOPY);

	pDibTmp->Unlock ();
	pDibTmp2->Unlock ();

	pDibNew->Blt (0, 0, Width * nSize, Height * nSize, pDibTmp2, 0, 0);

	bRet = TRUE;
Exit:
	SAFE_DELETE (pDibTmp);
	SAFE_DELETE (pDibTmp2);
	SAFE_DELETE_ARRAY (pLineBuf);

	return bRet;
}

/* Copyright(C)URARA-works 2006 */
